## silo 1.4.12-2ubuntu1

=== debian/changelog ===
silo (1.4.12-2ubuntu1) edgy; urgency=low
        
  * Disable gcc stack protector and fix FTBFS.

  * Use bash for make shell.
  (Closes Ubuntu: #61819)

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Fri, 15 Sep 2006 09:10:26 +0200

silo (1.4.12-2) unstable; urgency=low
	
  * Add a patch (20-silo_cdrom_boot_fix.patch) by David 
    Miller to fix the problems with booting from CD-ROM 
    on a variety of machines. Closes: #261824.
  * Set Section to admin to prevent the override disparity.
  * Update the upstream URL and FSF address in the
    copyright file (lintian warning).

 -- Jurij Smakov <jurij@debian.org>  Tue, 20 Jun 2006 19:24:55 -0700

silo (1.4.12-1) unstable; urgency=low

  * Acknowledge previous NMUs. Thanks to Frans Pop for excellent
    work. Closes: #306012, #349788, #359018.
  * Update to new upstream release (1.4.12).
  * Remove 10-sun4u_notimer.patch, included upstream.
  * Add 10-silo_get_architecture.patch, making it possible
    to build a working SILO with gcc-4.1. Closes: #369890.
  * Change the build-dependency from gcc-2.95 to gcc-4.1 and use it
    for building.
  * Add explicit build-dependency on perl, scripts in debian/scripts
    require it (lintian error).
  * Make sure that /etc/silo.conf is registered as conffile only
    once by modifying debian/packages.d/silo.in (lintian error).
  * Upstream does not ship a changelog anymore, adjust
    debian/rules appropriately.
  * Add myself to uploaders.

 -- Jurij Smakov <jurij@debian.org>  Tue, 13 Jun 2006 20:37:46 -0700

silo (1.4.11-0.2) unstable; urgency=low

  * Non-Maintainer Upload.
  * Replace sun4u_notimer patch by new patch from David Miller that should
    also work on Niagara systems.

 -- Frans Pop <fjp@debian.org>  Sat, 22 Apr 2006 16:43:17 +0200

silo (1.4.11-0.1) unstable; urgency=low

  * Non-Maintainer Upload. Closes: #359018.
    - New upstream release.
    - Include patch to restore second/timer.c from 1.4.10 to avoid regression
      seen on Ultra 10 where the system would no longer boot automatically
      after expiration of the timeout set in silo.conf.
    - Use debian/compat instead of setting debhelper compatibility in rules.

 -- Frans Pop <fjp@debian.org>  Fri, 14 Apr 2006 02:40:43 +0200

silo (1.4.10-0.1) unstable; urgency=low

  * Non-Maintainer Upload.
  * New upstream release. Closes: #306012, #349788.
  * Update debconf compatibility level to 5.
  * Fix lintian warning for "multiline-field build-depends".

 -- Frans Pop <fjp@debian.org>  Wed, 25 Jan 2006 15:23:27 +0100

=== debian/control ===
Source: silo
Section: admin
Priority: important
Maintainer: Ben Collins <bcollins@debian.org>
Uploaders: Jurij Smakov <jurij@debian.org>
Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper (>= 5.0), gcc-4.1, bzip2, sparc-utils, perl
Standards-Version: 3.2.1.0

Package: silo
Architecture: sparc
Depends: ${shlibs:Depends}
Replaces: sparc-utils (<< 1.8-1)
Description: Sparc Improved LOader
 Like LILO or MILO, but for SPARC.
 This is the program you need to use if you plan to boot SPARC/Linux
 via a hard drive, floppy or CDROM.  It installs to the boot block of
 your system and will allow for booting of Linux, Solaris, and SunOS.

=== debian/rules ===
#!/usr/bin/make -f

# the dbs rules
TAR_DIR := silo-1.4.12
include debian/scripts/dbs-build.mk

CC = "gcc-4.1 -m32 -fno-stack-protector"

build: $(STAMP_DIR)/build
$(STAMP_DIR)/build: $(STAMP_DIR)/patch
	dh_testdir
	cd $(BUILD_TREE) && $(MAKE) CC=$(CC)
	touch $(STAMP_DIR)/build

clean:
	dh_testdir
	rm -rf $(STAMP_DIR) $(SOURCE_DIR)
	perl debian/scripts/dh_split clean
	dh_clean

install: build $(dh_mak_deps)
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(BUILD_TREE) && $(MAKE) DESTDIR="$(shell pwd)/debian/silo" \
		install
	install -m755 debian/local/siloconfig debian/silo/usr/sbin/siloconfig

binary-indep:

binary-arch: build install $(dh_mak_deps)
	dh_testdir
	dh_testroot
	dh_installdocs $(BUILD_TREE)/docs/{README{,.tilo}} $(BUILD_TREE)/first-isofs/README.SILO_ISOFS
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch

## silo 1.4.13a+git20070930

=== Makefile ===
include Rules.make


# These only get built on Linux
ifeq ($(OPSYS),Linux)
  SUBDIRS  = common first second first-isofs tilo
  MANPAGES = maketilo.1 tilo.1
endif

# These get built on Linux and Solaris
MANPAGES += silo.8 silo.conf.5
SUBDIRS  += silo

all dep depend clean:
	@for I in $(SUBDIRS); do $(MAKE) -C $$I $@ || exit 1; done

ifeq ($(OPSYS),$(findstring $(OPSYS),Linux Solaris))
install:
	install -d -m755 $(DESTDIR)/etc $(DESTDIR)/sbin $(DESTDIR)/usr/sbin
	install -m755 silo/silo $(DESTDIR)/sbin
	install -m755 silo/silocheck $(DESTDIR)/usr/sbin
	[ -f $(DESTDIR)/etc/silo.conf ] || \
		install -m644 etc/silo.conf $(DESTDIR)/etc/
ifeq ($(OPSYS),Linux)
	install -d -m755 $(DESTDIR)/boot $(DESTDIR)/usr/bin
	install -m644 first/*.b second/*.b first-isofs/*.b $(DESTDIR)/boot/
	install -m755 tilo/maketilo $(DESTDIR)/usr/bin/
	install -m755 tilo/tilo.sh $(DESTDIR)/usr/bin/tilo
endif
	for manpage in $(MANPAGES); do \
		sect=`echo $$manpage | sed 's/.*\([1-8]\)$$/\1/'`; \
		install -d -m755 $(DESTDIR)/usr/share/man/man$$sect; \
		install -m644 man/$$manpage $(DESTDIR)/usr/share/man/man$$sect/; \
	done
	if test x"$(DESTDIR)" = x; then \
		echo "You need to run 'silo -f' now, to update the boot block" 1>&2; \
	fi
else
install:
	@echo SILO is only supported on SPARC Linux and Solaris.
endif

tag:
	svn copy -m "Tag $(VERSION)" svn://svn.sparc-boot.org/silo/trunk \
		svn://svn.sparc-boot.org/silo/tags/v$(VERSION)

# This is just for me to make release tarballs
release: ../silo-loaders-$(VERSION).tar.gz ../silo-$(VERSION).tar.gz ../silo-$(VERSION).tar.bz2
	rm -rf ../silo-$(VERSION) boot

../silo-loaders-$(VERSION).tar%:
	rm -rf ../silo-$(VERSION)
	svn export svn://svn.sparc-boot.org/silo/tags/v$(VERSION) \
		../silo-$(VERSION)
	install -d ../silo-$(VERSION)/boot
	for I in first first-isofs second; do $(MAKE) -C ../silo-$(VERSION)/$$I all || exit 1; done;
	install -d ../silo-$(VERSION)/boot
	(cd ../silo-$(VERSION); install -m644 first/*.b first-isofs/*.b second/*.b boot/)
	(cd ../silo-$(VERSION); \
		case "$*" in .gz) foo="gzip -c9";; .bz2) foo="bzip2 -c9";; *) foo=cat;; esac; \
		tar cf - boot | $$foo > $@; \
	)
	rm -rf ../silo-$(VERSION)

../silo-$(VERSION).tar%: clean
	rm -rf ../silo-$(VERSION)
	svn export svn://svn.sparc-boot.org/silo/tags/v$(VERSION) \
		../silo-$(VERSION)
	case "$*" in .gz) foo="gzip -c9";; .bz2) foo="bzip2 -c9";; *) foo=cat;; esac; \
		(cd ../ && tar cf - silo-$(VERSION)) | $$foo > $@
	rm -rf ../silo-$(VERSION)

=== first/Makefile ===
##
## Linux Loader for SPARC
##
#

DD=dd

include ../Rules.make

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
# Changing this value will require changing a bunch of other constants throughout the code
LDFLAGS=-N -Ttext 0x4000

.S.o:
	$(CC) $(CFLAGS) -c $*.S

all: first.b first.h ultra.b ultra.h generic.b generic.h fd.b ieee32.b

first.h: first
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define DIGIT_OFFSET_TMP 0x\2/p' < first.map > first.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define LETTER_OFFSET_TMP 0x\2/p' < first.map >> first.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define NUMBER_OFFSET_TMP 0x\2/p' < first.map >> first.h
ultra.h: ultra
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define ULTRA_LETTER_OFFSET_TMP 0x\2/p' < ultra.map > ultra.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define ULTRA_NUMBER_OFFSET_TMP 0x\2/p' < ultra.map >> ultra.h
generic.h: generic
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define GENERIC_DIGIT_OFFSET_TMP 0x\2/p' < generic.map > generic.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define GENERIC_LETTER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define GENERIC_NUMBER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
fd.h: fd
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define FD_DIGIT_OFFSET_TMP 0x\2/p' < fd.map > fd.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define FD_LETTER_OFFSET_TMP 0x\2/p' < fd.map >> fd.h

first.o: first.S
	$(CC) $(CFLAGS) -c first.S -o first.o

first: first.o
	$(LD) $(LDFLAGS) -o first first.o
	$(NM) first | grep -v '*ABS*' | sort > first.map
	$(STRIP) first

first.b: first
	$(ELFTOAOUT) -o first.b first
	printf 'SILO'$(IMGVERSION) | $(DD) of=first.b bs=8 conv=notrunc seek=3 count=1
	$(DD) if=/dev/zero of=first.b bs=4 count=1 seek=127

ultra.o: ultra.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a ultra.S

ultra: ultra.o
	$(LD) $(LDFLAGS) -o ultra ultra.o
	$(NM) ultra | grep -v '*ABS*' | sort > ultra.map
	$(STRIP) ultra

ultra.b: ultra
	$(ELFTOAOUT) -o ultra.b ultra
	printf 'SILO'$(IMGVERSION) | $(DD) of=ultra.b bs=8 conv=notrunc seek=3 count=1
	printf '\340' | $(DD) of=ultra.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=ultra.b bs=4 count=1 seek=127

generic.o: generic.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a generic.S

generic: generic.o
	$(LD) $(LDFLAGS) -o generic generic.o
	$(NM) generic | grep -v '*ABS*' | sort > generic.map
	$(STRIP) generic

generic.b: generic
	$(ELFTOAOUT) -o generic.b generic
	printf 'SILO'$(IMGVERSION) | $(DD) of=generic.b bs=8 conv=notrunc seek=3 count=1
	printf '\340' | $(DD) of=generic.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=generic.b bs=4 count=1 seek=255

fd.o: fd.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a fd.S

fd: fd.o
	$(LD) $(LDFLAGS) -o fd fd.o
	$(NM) fd | grep -v '*ABS*' | sort > fd.map
	$(STRIP) fd

fd.b: fd
	$(ELFTOAOUT) -o fd.b fd
	printf 'SILO'$(IMGVERSION) | $(DD) of=fd.b bs=8 conv=notrunc seek=3 count=1
	printf '\340' | $(DD) of=fd.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=fd.b bs=4 count=1 seek=255

ieee32.o: ieee32.S ieee32.h
	$(CC) $(CFLAGS) -DIMGVERSION='"SILO$(IMGVERSION)"' -c ieee32.S

ieee32.b: ieee32.o
	$(LD) $(LDFLAGS) -o ieee32.b ieee32.o
	$(NM) ieee32.b | grep -v '*ABS*' | sort > ieee32.map
	$(STRIP) ieee32.b
	chmod 644 ieee32.b

clean:
	$(RM) *.o *.map *.b first first.h ultra ultra.h \
	generic generic.h fd fd.h

=== silo/Makefile ===
include ../Rules.make

PROGRAMS=silo silocheck
UFSDEPS=

CFLAGS=-O2 -Wall -I. -I../include

ifeq ($(OPSYS),Solaris)
  UFSDEPS=../second/ufs.c ufs.h
endif

all: $(PROGRAMS)

HEADERS=../first/first.h ../first/ultra.h ../first/fd.h
SILO_OBJS=confcheck.o prom.o silo.o
SILOCHK_OBJS=silocheck.o

silo: $(HEADERS) $(SILO_OBJS)
	$(CC) -o $@ $(SILO_OBJS)

silocheck: $(SILOCHK_OBJS) $(UFSDEPS)
	$(CC) -o $@ $(SILOCHK_OBJS)

floppy.h: floppy.label $(BIN2H)
	$(BIN2H) floppy_label floppy.label > floppy.h

ufs.h: ../second/ufs.h
	ln -f ../second/ufs.h ufs.h

$(HEADERS):
	$(MAKE) -C ../first first.h ultra.h fd.h

silo.o: silo.c floppy.h $(UFSDEPS)
	$(CC) $(CFLAGS) -DVERSION='"$(VERSION)"' -DIMGVERSION='"$(IMGVERSION)"' -c silo.c

clean:
	$(RM) *.o silo floppy.h ufs.h silocheck

## silo 1.4.13-1

=== common/Makefile ===
##
## Common files between tilo and silo
##

include ../Rules.make

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.S.o:
	$(CC) $(CFLAGS) -c $*.S

OBJS = sdiv.o rem.o udiv.o urem.o jmp.o printf.o console.o prom.o tree.o stringops2.o\
	stringops1.o ffs.o divdi3.o udivdi3.o
PROGRAMS = bin2h

all: $(OBJS) $(PROGRAMS)

prom.o: prom.c
	$(CC) $(CFLAGS) -c -Wa,-Av9 -o prom.o prom.c

clean:
	$(RM) $(PROGRAMS) *.o

=== first-isofs/Makefile ===
##
## CD Linux Loader for SPARC
##

include ../Rules.make

LDFLAGS = -N -Ttext 0x4000

NAME = isofs

all: $(NAME).b

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.S.o:
	$(CC) $(CFLAGS) -c $*.S

OBJS_COMMON = ../common/prom.o ../common/console.o ../common/tree.o
OBJS = crt0.o $(NAME).o $(OBJS_COMMON)

$(NAME): $(OBJS)
	$(LD) $(LDFLAGS) -Bstatic -o $@ $(OBJS)

$(NAME).b: $(NAME)
	dd if=/dev/zero bs=512 count=1 of=$@
	$(ELFTOAOUT) $< -o $<.aout || ($(RM) $@ && exit 1)
	cat $<.aout >> $@

crt0.o:	crt0.S
	$(CC) $(CFLAGS) -c -Wa,-Av9 -o $@ $<

clean:
	$(RM) *.o $(NAME) $(NAME).b $(NAME).aout

=== debian/changelog ===
silo (1.4.13-1) unstable; urgency=low

  * New upstream release.
  * Drop 10-silo_get_architecture.patch and 20-silo_cdrom_boot_fix.patch
    as they have been included upstream (those were the only upstream
    changes).
  * Add 10-silo_new_ufs_superblock.patch to make it possible to build
    silo against new linux-kernel-headers, where ufs_super_block 
    structure has been split into ufs_super_block_{first,second,third}.
    Closes: #393114.
  * Add a build dependency on linux-kernel-headers (>= 2.6.18), that's
    where this change was first introduced.

 -- Jurij Smakov <jurij@debian.org>  Mon, 16 Oct 2006 20:37:29 -0700
  

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: important
 Maintainer: Ben Collins <bcollins@debian.org>
 Uploaders: Jurij Smakov <jurij@debian.org>
-Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper (>= 5.0), gcc-4.1, bzip2, sparc-utils, perl
+Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper (>= 5.0), gcc-4.1, bzip2, sparc-utils, perl, linux-kernel-headers (>= 2.6.18)
 Standards-Version: 3.2.1.0
 
 Package: silo

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,10 @@
 #!/usr/bin/make -f
 
 # the dbs rules
-TAR_DIR := silo-1.4.12
+TAR_DIR := silo-1.4.13
 include debian/scripts/dbs-build.mk
 
-CC = "gcc-4.1 -m32 -fno-stack-protector"
+CC = "gcc-4.1 -m32"
 
 build: $(STAMP_DIR)/build
 $(STAMP_DIR)/build: $(STAMP_DIR)/patch

## silo 1.4.13-1ubuntu5

=== debian/changelog ===
silo (1.4.13-1ubuntu5) feisty; urgency=low
  
  * Convert silo.conf to use /dev/disk/by-uuid.

  * Set maintainer stuff for ubuntu.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Fri, 16 Mar 2007 13:51:58 +0100

silo (1.4.13-1ubuntu4) feisty; urgency=low
  
  * Change silo.postinst to automatically update the boot block without
    invoking siloconfig and keep asking questions on upgrades.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Mon, 08 Jan 2007 08:26:01 +0100

silo (1.4.13-1ubuntu3) feisty; urgency=low
  
  * Add patch 50-silo_needs_printf_instead_of_echo.patch or all *.b files are
    hutterly broken.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Mon, 18 Dec 2006 18:09:08 -0800

silo (1.4.13-1ubuntu2) feisty; urgency=low
  
  * Add patch 40-silo_needs_ufs_headers.patch to fix FTBFS since ufs headers
    are not exported by the kernel anymore.

  * fix debian/rules dh_installdocs shell expantion.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Mon, 18 Dec 2006 13:05:20 -0800

silo (1.4.13-1ubuntu1) feisty; urgency=low

  * Merge from debian unstable:
    * Change build-dep from linux-kernel-headers to linux-libc-dev

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Wed, 08 Nov 2006 02:51:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: silo
 Section: admin
 Priority: important
-Maintainer: Ben Collins <bcollins@debian.org>
+Maintainer: Fabio M. Di Nitto <fabbione@ubuntu.com>
+XSBC-Original-Maintainer: Ben Collins <bcollins@debian.org>
 Uploaders: Jurij Smakov <jurij@debian.org>
-Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper (>= 5.0), gcc-4.1, bzip2, sparc-utils, perl, linux-kernel-headers (>= 2.6.18)
+Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper (>= 5.0), gcc-4.1, bzip2, sparc-utils, perl, linux-libc-dev (>= 2.6.18)
 Standards-Version: 3.2.1.0
 
 Package: silo

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 TAR_DIR := silo-1.4.13
 include debian/scripts/dbs-build.mk
 
-CC = "gcc-4.1 -m32"
+CC = "gcc-4.1 -m32 -fno-stack-protector"
 
 build: $(STAMP_DIR)/build
 $(STAMP_DIR)/build: $(STAMP_DIR)/patch
@@ -33,7 +33,7 @@
 binary-arch: build install $(dh_mak_deps)
 	dh_testdir
 	dh_testroot
-	dh_installdocs $(BUILD_TREE)/docs/{README{,.tilo}} $(BUILD_TREE)/first-isofs/README.SILO_ISOFS
+	dh_installdocs $(BUILD_TREE)/docs/README{,.tilo} $(BUILD_TREE)/first-isofs/README.SILO_ISOFS
 	dh_installchangelogs
 	dh_strip
 	dh_compress

## silo 1.4.14+git20100228

=== Makefile ===
--- 
+++ 
@@ -41,17 +41,18 @@
 endif
 
 tag:
-	svn copy -m "Tag $(VERSION)" svn://svn.sparc-boot.org/silo/trunk \
-		svn://svn.sparc-boot.org/silo/tags/v$(VERSION)
+	git-tag -s -m "Tag v$(VERSION)" v$(VERSION)
 
 # This is just for me to make release tarballs
-release: ../silo-loaders-$(VERSION).tar.gz ../silo-$(VERSION).tar.gz ../silo-$(VERSION).tar.bz2
+release: ../silo-$(VERSION).tar.gz ../silo-$(VERSION).tar.bz2
 	rm -rf ../silo-$(VERSION) boot
+# ../silo-loaders-$(VERSION).tar.gz
 
 ../silo-loaders-$(VERSION).tar%:
 	rm -rf ../silo-$(VERSION)
-	svn export svn://svn.sparc-boot.org/silo/tags/v$(VERSION) \
-		../silo-$(VERSION)
+	git-clone `pwd` ../silo-$(VERSION)
+	(cd ../silo-$(VERSION); git-branch v$(VERSION) v$(VERSION); git-checkout v$(VERSION))
+	rm -rf ../silo-$(VERSION)/.git
 	install -d ../silo-$(VERSION)/boot
 	for I in first first-isofs second; do $(MAKE) -C ../silo-$(VERSION)/$$I all || exit 1; done;
 	install -d ../silo-$(VERSION)/boot
@@ -64,8 +65,9 @@
 
 ../silo-$(VERSION).tar%: clean
 	rm -rf ../silo-$(VERSION)
-	svn export svn://svn.sparc-boot.org/silo/tags/v$(VERSION) \
-		../silo-$(VERSION)
+	git-clone `pwd` ../silo-$(VERSION)
+	(cd ../silo-$(VERSION); git-branch v$(VERSION) v$(VERSION); git-checkout v$(VERSION))
+	rm -rf ../silo-$(VERSION)/.git
 	case "$*" in .gz) foo="gzip -c9";; .bz2) foo="bzip2 -c9";; *) foo=cat;; esac; \
 		(cd ../ && tar cf - silo-$(VERSION)) | $$foo > $@
 	rm -rf ../silo-$(VERSION)

=== second/Makefile ===
##
## Linux Loader for SPARC
##
##

AS=as
AR=ar
NM=nm
DD=dd
AWK=awk
LS=ls
STRIP=strip
GZIP=gzip
GDB=gdb
ECHO=echo
GREP=grep
SED=sed
CP=cp

include ../Rules.make

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
#
# XXX: We seem to be going 4Megs here for LARGE? -- BenC
LDFLAGS_SMALL=-N -Ttext $(SMALL_RELOC)
LDFLAGS_LARGE=-N -Ttext $(LARGE_RELOC)

.c.o:
	$(CC) $(CFLAGS) -c $*.c -o $@

.S.o:
	$(CC) $(CFLAGS) -c $*.S -o $@

# The ordering here is very significant. Please add new object files to OBJS5 only.
OBJS1 = crt0.o
OBJS2 = decomp.o
OBJS2N = decompnet.o
OBJS3 = ../common/console.o ../common/printf.o malloc.o ../common/jmp.o \
	../common/prom.o ../common/tree.o ../common/urem.o ../common/udiv.o \
	../common/stringops1.o ../common/ffs.o ../common/divdi3.o \
	../common/udivdi3.o
OBJS4 = main.o
OBJS4N = mainnet.o
OBJS5 = cmdline.o disk.o file.o misc.o cfg.o strtol.o ranges.o timer.o \
	memory.o fs/libfs.a mul.o ../common/rem.o ../common/sdiv.o umul.o \
	../common/stringops2.o ls.o muldi3.o
OBJS = $(OBJS1) $(OBJS2) $(OBJS3) bmark.o $(OBJS4) $(OBJS5)
OBJSNET = $(OBJS1) $(OBJS2N) $(OBJS3) bmark.o $(OBJS4N) $(OBJS5)

FS_OBJS = fs/iom.o fs/ext2.o fs/isofs.o fs/romfs.o fs/ufs.o

# Should really switch to autoconf...
all: second.b silotftp.b

fs/libfs.a: $(FS_OBJS)
	$(RM) $@
	$(AR) rc $@ $(FS_OBJS)

second: $(OBJS) mark.o
	$(LD) $(LDFLAGS_SMALL) -Bstatic -o second $(OBJS) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
	$(LD) $(LDFLAGS_LARGE) -Bstatic -o second2 $(OBJS) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
	$(NM) second | grep -v '*ABS*' | sort > second.map

silotftp: $(OBJSNET) mark.o
	$(LD) $(LDFLAGS_SMALL) -Bstatic -o silotftp $(OBJSNET) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
	$(LD) $(LDFLAGS_LARGE) -Bstatic -o silotftp2 $(OBJSNET) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
	$(NM) silotftp | grep -v '*ABS*' | sort > silotftp.map

second.l: second
	( $(ECHO) 'disassemble $(SMALL_RELOC) '`$(GREP) '_etext' second.map | $(SED) 's/ .*$$//' | $(SED) 's/^00/0x/'`; $(ECHO) quit ) | $(GDB) second | $(SED) '1,/^(gdb)/d;/^End /,$$d' > second.l

file.o:	       file.c

decompnet.o:   decomp.c
	$(CC) $(CFLAGS) -DTFTP -DVERSION='"$(VERSION)"' -c -o $@ $<

decomp.o: decomp.c
	$(CC) $(CFLAGS) -DVERSION='"$(VERSION)"' -c $<

mainnet.o:   main.c
	$(CC) $(CFLAGS) -DTFTP -c -o $@ $<

malloc.o: ../common/malloc.c
	$(CC) $(CFLAGS) -c -o $@ $<

util:	util.c
	$(CC) -DSMALL_RELOC=$(SMALL_RELOC) -DLARGE_RELOC=$(LARGE_RELOC) -o $@ $<

clean:
	$(RM) *.o fs/*.o second* silotftp* util fs/libfs.a

crt0.o:	crt0.S
	$(CC) $(CFLAGS) -c -Wa,-Av9 -DIMGVERSION='"SILO$(IMGVERSION)"' crt0.S

memory.o: memory.c
	$(CC) $(CFLAGS) -c -Wa,-Av9 memory.c

timer.o: timer.c
	$(CC) $(CFLAGS) -c -Wa,-Av9a timer.c

second.b: second util
	$(ELFTOAOUT) -o second.aout second
	$(ELFTOAOUT) -o second2.aout second2
	./util second.map second.aout second2.aout second.b second.b2
	$(GZIP) -9cfn second.b2 >> second.b
	$(DD) if=/dev/zero bs=1 count=`$(LS) -l second.b | $(AWK) '{len=$$5%512;if(len!=0)len=512-len;print len}'` >> second.b
	$(LS) -l second.b | $(AWK) '{printf "%c%c%c%c",0,$$5/65536,($$5%65536)/256,0}' | $(DD) of=second.b bs=4 count=1 seek=581 conv=notrunc

silotftp.b: silotftp util
	$(ELFTOAOUT) -o silotftp.aout silotftp
	$(ELFTOAOUT) -o silotftp2.aout silotftp2
	./util -a silotftp.map silotftp.aout silotftp2.aout silotftp.b silotftp.b2
	$(GZIP) -9cfn silotftp.b2 >> silotftp.b

## silo 1.4.14+git20120819

=== second/Makefile ===
--- 
+++ 
@@ -58,13 +58,13 @@
 	$(AR) rc $@ $(FS_OBJS)
 
 second: $(OBJS) mark.o
-	$(LD) $(LDFLAGS_SMALL) -Bstatic -o second $(OBJS) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
-	$(LD) $(LDFLAGS_LARGE) -Bstatic -o second2 $(OBJS) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
+	$(LD) $(LDFLAGS_SMALL) -Bstatic -o second $(OBJS) mark.o `$(CC) -print-libgcc-file-name`
+	$(LD) $(LDFLAGS_LARGE) -Bstatic -o second2 $(OBJS) mark.o `$(CC) -print-libgcc-file-name`
 	$(NM) second | grep -v '*ABS*' | sort > second.map
 
 silotftp: $(OBJSNET) mark.o
-	$(LD) $(LDFLAGS_SMALL) -Bstatic -o silotftp $(OBJSNET) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
-	$(LD) $(LDFLAGS_LARGE) -Bstatic -o silotftp2 $(OBJSNET) -lext2fs mark.o `$(CC) -print-libgcc-file-name`
+	$(LD) $(LDFLAGS_SMALL) -Bstatic -o silotftp $(OBJSNET) mark.o `$(CC) -print-libgcc-file-name`
+	$(LD) $(LDFLAGS_LARGE) -Bstatic -o silotftp2 $(OBJSNET) mark.o `$(CC) -print-libgcc-file-name`
 	$(NM) silotftp | grep -v '*ABS*' | sort > silotftp.map
 
 second.l: second

=== debian/changelog ===
silo (1.4.14+git20120819-2) unstable; urgency=low

  * New Maintainer (Closes: #721498, #677780)
  * Apply wrap-and-sort and remove obsolete local variables from the
    bottom of debian/changelog.
  * Switch VCS repository to git, update Vcs-* headers acoordingly.
  * Enable sparc64 architecture (Closes: #721396)
  * Make tilo.sh (/usr/bin/tilo) work again
    + Add patch to work with newer "file" versions (Closes: #730651)
    + Add patch to find the root address also in more recent kernels
  * Recommend "file" as tilo needs it to run.
  * Rewrite long description to not suggest it's the only Sparc boot loader
    in Debian.
  * Mention tilo and its requirments in the long description.
  * Bump debhelper compatibility to 9.
    + Update versioned debhelper build-dependency accordingly.
  * Switch to source format "3.0 (quilt)"
    + No more build outside the tree
    + Remove quilt build-dependency and quilt traces from debian/rules.
    + Remove now obsolete debian/README.source
  * Revamp debian/rules:
    + Replace "dh_clean -k" with "dh_prep", fixes lintian warning
      dh-clean-k-is-deprecated
    + Use dh_auto_{build,install,clean}
    + No more clean up stamp files manually, dh_clean does that now.
    + Use debian/{docs,manpages} instead of parameters to
      dh_install{docs,man}. Rename directory debian/{manpages → man}
    + Use debian/install + dh_install instead of manually calling install.
    + Finally switch to a minimal dh7 style debian/rules file.
  * Add upstream git repository webpage as Homepage header. Fixes lintian
    warning no-homepage-field.
  * Bump Standards-Version to 3.9.5
    + Introduce a Built-Using field
  * Add patch to fix the following lintian warnings in upstream man pages:
    + hyphen-used-as-minus-sign
    + spelling-error-in-manpage
  * Additionally this upload fixes the following lintian warnings:
    + dm-upload-allowed-is-obsolete
    + hyphen-used-as-minus-sign (in debian/man/silocheck.8)
    + maintainer-script-without-set-e
    + copyright-refers-to-symlink-license

 -- Axel Beckert <abe@debian.org>  Fri, 29 Nov 2013 01:50:28 +0100

silo (1.4.14+git20120819-1) unstable; urgency=low

  [ Jurij Smakov ]
  * New upstream release containing only the following bug fixes:
    - Fix ext4 extent resolution. Without this fix silo fails to
      read silo.conf off a ext4 filesystem.
      Commit: 6ab3e76216353af6b60a99f7e5ebf5611047c831
    - Fix silo crash on Niagara (sun4v) machines whenever 'timeout'
      parameter is used in silo.conf. (Closes: #685245)
      Commits: 1121ecf7b087b940339e421b2928067c92f6237e
               dcee4ca86e88aeec8c6f2c8062035419204b4701
    - Include stddef.h in stringops.h. Fixes build failure when
      compiled against 3.4 Linux headers.
      Commit: 2999c98e8241b81cb35846961672fc7d8c3fe235

 -- Jurij Smakov <jurij@debian.org>  Sun, 19 Aug 2012 16:14:18 +0100

silo (1.4.14+git20120226-1) unstable; urgency=low

  [ Jurij Smakov ]
  * New upstream release fixing the block and offset calculation
    for group descriptors on ext2/3 filesystems.

 -- Jurij Smakov <jurij@debian.org>  Sun, 26 Feb 2012 17:28:53 +0000

silo (1.4.14+git20120127-1) unstable; urgency=low

  [ Jurij Smakov ]
  * Failure to build against recent e2fslibs versions
    is fixed upstream. (Closes: #655897)
  * Add David Miller to copyright owners list in debian/copyright,
    mentioned in second/fs/ext2.c.
  * Add recommended build-arch and build-indep debian/rules targets
    (lintian warning).
  * Bump Standards-Version to 3.9.2, no changes necessary.
    (lintian warning).

 -- Jurij Smakov <jurij@debian.org>  Wed, 01 Feb 2012 21:06:11 +0000

silo (1.4.14+git20100228-1) unstable; urgency=low

  [ Jurij Smakov]
  * Remove the following Debian patches merged upstream:
    - silo-linux-types.patch
      (merged as eb1b1642b586cfe2b99cf890a7849226beac4e9b)
    - silo-revert-relocation-commit.patch
      (merged as 93cc5699a11424177960afa4b6a8bd6cbc72dcd9)
    No Debian-specific patches remaining.
  * Fix the build-tree target in debian/rules to not fail when
    the quilt series file is empty.

 -- Jurij Smakov <jurij@debian.org>  Sun, 28 Feb 2010 11:23:12 +0000

silo (1.4.14+git20100207-1) unstable; urgency=low

  [ Jurij Smakov ]
  * SILO is now maintained upstream by David Miller in his own
    git tree. Update the instructions on obtaining the source code
    in debian/copyright to reflect that.
  * Remove the following Debian patches merged upstream:
    - 11-silocheck_non-failure_on_stat.patch
      (merged as 35ebde57a694569d38f95983e73aa9ad610f7796)
    - 20-silo_ls_fix_date_calc.patch
      (merged as f820825406a49fea6b166377ec637b2dedb9ba2e)
    - silo.git-eb6151388752b52804f80ff27e90ec2dbde71339.patch
    - silo.git-a55764ceef83086d00b5f7b8b3027b517fc4ca23.patch
  * Add silo-linux-types.patch to fix an FTBFS caused by changes in
    the linux-libc-dev headers, which are now defining _LINUX_TYPES_H
    again. Bump linux-libc-dev build-dep to >= 2.6.32.
  * Add silo-revert-relocation-commit.patch reverting upstream
    commit 71816c5699b32bab03e57be6768a562d9568e33b which breaks
    SILO (fails to boot).
  * Build with default GCC, remove build-dep on gcc-4.3.
    (Closes: #533811)
  * Fix bashism in debian/rules. (Closes: #535419)
  * Remove bcollins from Uploaders at the request of MIA team.
    Thanks for all the fish, Ben. (Closes: #540902)
  * Add ${misc:Depends} to dependencies (lintian warning).
  * Add debian/README.source (lintian warning).
  * Bump Standards-Version to 3.8.4, no changes necessary
    (lintian warning).
  * Call siloconfig without explicit path in postinst
    (lintian warning).
  * Set -e in postinst to abort on errors (lintian warning).

 -- Jurij Smakov <jurij@debian.org>  Sun, 07 Feb 2010 10:49:43 +0000

silo (1.4.13a+git20070930-3) unstable; urgency=low

  [ Jurij Smakov ]
  * Include patches eb6151388752b52804f80ff27e90ec2dbde71339 and
    a55764ceef83086d00b5f7b8b3027b517fc4ca23 from the git tree to


=== debian/control ===
Source: silo
Section: admin
Priority: important
Maintainer: Debootloaders SILO Maintainers Team <debootloaders-silo@lists.alioth.debian.org>
Uploaders: Axel Beckert <abe@debian.org>
Build-Depends: bzip2,
               debhelper (>= 9~),
               e2fslibs-dev (>= 1.28),
               linux-libc-dev (>= 2.6.32),
               perl,
               sparc-utils
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/debootloaders/silo.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debootloaders/silo.git
Homepage: https://git.kernel.org/cgit/linux/kernel/git/davem/silo.git/

Package: silo
Architecture: sparc sparc64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: file
Replaces: sparc-utils (<< 1.8-1)
Built-Using: ${Built-Using}
Description: Sparc Improved LOader
 SILO is a boot loader similar to LILO or MILO, but to boot Linux on
 Sparc hardware. It can be used on hard drives, floppies or CDROM and
 allows booting Linux, Solaris, and SunOS.
 .
 Includes TILO, the Trivial Image LOader, for building TFTP boot
 loaders which can embody several kernel images for different Sun
 architectures as well as an RAM disk root image (i.e. an initrd).
 tilo needs "file" being installed to run properly.

=== debian/rules ===
#!/usr/bin/make -f

BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W e2fslibs-dev linux-libc-dev)

CC         = "gcc -m32"

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CC=$(CC)

override_dh_gencontrol:
	dh_gencontrol -a -- -VBuilt-Using="$(BUILT_USING)"
